<template>
  <section class="add-todo">
    <form v-if="formVisible" @submit.prevent="addTask" class="add-todo__form">
      <button @click="close" class="close-button" type="button">
        <i class="bi bi-x"></i>
      </button>
      <div class="text-input text-input--focus">
        <input v-model="title" class="input" />
      </div>
      <span>{{ error }}</span>
      <button class="button button--filled">Add task</button>
    </form>
    <button @click="open" v-else class="add-todo__show-form-button">
      <i class="bi bi-plus-lg"></i>
    </button>
  </section>
</template>
<script setup lang="ts">
import { ref } from "vue";
import { Todo } from "../types/Todo";

const title = ref<string>("");
const formVisible = ref<boolean>(false);
const error = ref<string>("");
const open = () => {
  formVisible.value = true;
};

const close = () => {
  formVisible.value = false;
};

const addTask = () => {
  if (!title.value) {
    error.value = "enter title";
    return;
  }
  let newTask: Todo = {
    id: Date.now(),
    title: title.value,
    completed: false,
    userId: 0,
  };
  error.value = "";
  title.value = "";
  emit("addTask", newTask);
};

const emit = defineEmits<{
  (e: "addTask", task: Todo): void;
}>();
</script>
